<template>
  <div>
    <draggable v-model="nodeData" :options="{ handle: '.handle', animation: 300, ghostClass: 'draggable-ghost', chosenClass: 'draggable-chosen' }">
      <div v-for="(embed, index) in nodeData" v-if="embed" :key="getId(embed) || index" class="reference-item">
        <div class="handle">☰</div>
        <items-reference-form :title="config.label + (getId(embed) ? ' #' + getId(embed) : ' new')" :node="node" :path="[...path, index]"></items-reference-form>
        <delete-item-form :node="node" :path="[...path, index]"></delete-item-form>
      </div>
    </draggable>
  </div>
</template>

<script>
import _ from 'lodash'
import draggable from 'vuedraggable'

import { mapActions, mapGetters } from 'vuex'

export default {
  components: {
    draggable,
    ItemsReferenceForm: () => import('./ItemsReferenceForm.vue'),
    DeleteItemForm: () => import('./DeleteItemForm.vue')
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // config: {
    //   type: Object,
    //   required: true
    // },
    // options: {
    //   type: Object,
    //   required: false,
    //   default: () => {}
    // }
  },

  data () {
    return {
    }
  },

  computed: {
    ...mapGetters({
      // getEditedField: 'Y3TI/getEditedField',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },
    // type () {
    //   return this.getEditedField({ node: this.node, path: [...this.path, '_type'] })
    // },

    nodeData: {
      get () {
        return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, {})
      },
      set (value) {
        this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: value } })
        // this.$store.commit('updateList', value)
      }
    }
    // fieldsConfig () {
    //   return this.config.fields || {}
    // }
    // ...mapGetters({
    //   getEditableNodes: 'Y3TI/getEditableNodes',
    //   getFieldConfig: 'Y3TI/getFieldConfig'
    // }),

    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // }
    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    // ...mapActions({
    //   changeEditableParagraphType: 'Y3TI/changeEditableParagraphType'
    // }),

    // typeChanged () {
    //   if (this.type) {
    //     this.changeEditableParagraphType({ data: { node: this.node, path: this.path, config: this.config, type: this.type } })
    //     // this.updateMultipleEditableFieldsData({ data: { node: this.node, path: this.path, config: this.config.ref[this.type].fields } })
    //   }
    // }
    ...mapActions({
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    }),

    getId (item) {
      return item.pid || item.mid
    }
    // update (e) {
    //   this.storeEditableFieldData({ data: { path: this.editablePath, input: e.target.innerHTML } })
    // }
  }
}
</script>

<style lang="scss" scoped>
  .reference-item {
    background-color: orange;
    border: 2px solid yellow;
  }
  .draggable-ghost {
    opacity: 0.5;
  }
  .draggable-chosen {
    .handle {
      cursor: -webkit-grabbing;
    }
  }
  .handle {
    cursor: -webkit-grab;
  }
</style>
